<!-- 添加/编辑商品  -->
<template>
  <div>
    <el-dialog :append-to-body="true" :close-on-click-modal="false" :title="id|dialogTitle('商品')" :visible.sync="Show" width="1000px">
      <div v-loading="m_tableLoading">
        <el-tabs v-model="tabActive">
          <el-tab-pane label="基本信息" name="1"></el-tab-pane>
          <el-tab-pane v-if="isSetOptions" label="规格设置" name="4"></el-tab-pane>
          <el-tab-pane label="内容描述" name="2"></el-tab-pane>
          <el-tab-pane label="参数设置" name="3"></el-tab-pane>
        </el-tabs>

        <el-form :model="formData" :rules="m_rules" ref="ruleForm">
          <div v-show="tabActive==1">
            <el-form-item label="名称" label-width="80px" prop="title">
              <zw-input v-model="formData.title"></zw-input>
            </el-form-item>

            <el-form-item label="图片" label-width="80px" prop="images">
              <div class="">
                <div class="imgss" v-for="(item,index) in formData.images" :key="index">
                  <i @click="delImgs(index)" class="el-icon-error imgss_color"></i>
                  <img :src="item" class="avatar ml10">
                </div>
                <el-upload class="upload-demo" name="images" :show-file-list="false" :action="m_action" :on-success="handleAvatarSuccessImgs">
                  <el-button size="small" type="primary">点击上传</el-button>

                </el-upload>
                <div class="m_red">(建议上传1:1规格图片,大小不超过200kb)</div>
              </div>

            </el-form-item>

            <el-form-item label="分类" label-width="80px" prop="category_info">
              <div>
                <el-tag class="mb5 mr5" v-for="(item,index ) in formData.category_info" @close="closeTag(item,index)" :key="item.id" closable type='warning'>
                  {{item.name}}
                </el-tag>
              </div>
              <zw-btn @click="handleChoose" class="ml5" type="primary">选择分类</zw-btn>
            </el-form-item>

            <zw-row>
              <el-form-item label="价格" label-width="80px" prop="price">
                <zw-input type="number" v-model="formData.price"></zw-input>
              </el-form-item>

              <el-form-item label="原价" label-width="80px" prop="original_price">
                <zw-input type="number" v-model="formData.original_price"></zw-input>
              </el-form-item>

              <el-form-item label="成本" label-width="80px" prop="cost_price">
                <zw-input type="number" v-model="formData.cost_price"></zw-input>
              </el-form-item>
            </zw-row>

            <div class="flex">
              <el-form-item label="虚拟销量" label-width="80px" prop="sale_num">
                <zw-input type="number" v-model="formData.sale_num"></zw-input>
              </el-form-item>

              <el-form-item label="库存" label-width="80px" prop="stock">
                <zw-input type="number" v-model="formData.stock"></zw-input>
              </el-form-item>

              <el-form-item label="产品来源" label-width="80px" prop="source_from">
                <zw-select :hasNull="false" v-model="formData.source_from" :List="source_from" />
              </el-form-item>
            </div>

            <div class="flex">
              <el-form-item label="单位" label-width="80px" prop="unit">
                <zw-input placeholder="如:个,件,箱" v-model="formData.unit"></zw-input>
              </el-form-item>

              <el-form-item label="重量(克)" label-width="80px" prop="weight">
                <zw-input v-model="formData.weight"></zw-input>
              </el-form-item>

              <el-form-item label="排序" label-width="80px" prop="sort">
                <zw-input type="number" v-model="formData.sort"></zw-input>
                <div class="m_red">(从大到小排序,数值越大越靠前)</div>
              </el-form-item>

            </div>
            <!-- item end price -->
            <div class="flex">
              <el-form-item label="团购价" label-width="80px" prop="item_endprice">
                <zw-input placeholder="团购价" v-model="formData.item_endprice"></zw-input>
              </el-form-item>

              <el-form-item label="起步团购" label-width="80px" prop="min_item_endprice">
                <zw-input placeholder="起步团购" v-model="formData.min_item_endprice"></zw-input>
              </el-form-item>

               <el-form-item label-width="80px" v-if="userInfo.group_id != 2">
               <zw-btn  v-show="!currentComponent" v-if="formData.reward_mode==0" @click="rewardMode" class="ml5" type="primary">可用积分折扣</zw-btn> 
               <zw-btn v-else  @click="rewardMode" class="ml5" type="info">折扣点不可用</zw-btn> 
              </el-form-item>
              
            </div>


              <el-form-item label="总限购" label-width="80px" prop="total_limit">
                <zw-input class="w200"  type="number" v-model="formData.total_limit"></zw-input>
                <div class="m_red">(0 为不限购)</div>
              </el-form-item>


              <el-form-item v-if="formData.cupon_url" label="优惠券链接:" label-width="90px" prop="weight">
                <span >{{formData.cupon_url}}</span>
                 <el-button class="ml5" @click="open(formData.cupon_url)" type="text" size="mini">复制链接</el-button>
              </el-form-item>

              <el-form-item v-if="formData.item_url" label="宝贝链接:" label-width="90px" prop="weight">
                <span >{{formData.item_url}}</span>
                 <el-button class="ml5" @click="open(formData.item_url)" type="text" size="mini">复制链接</el-button>
              </el-form-item>

               <zw-row>

                 <el-form-item label="是否给收据" label-width="120px" prop="receipt_required">
                   <el-radio-group v-model="formData.receipt_required" class="w200">
                     <el-radio :label="1" :key="1">是</el-radio>
                     <el-radio :label="0" :key="0">否</el-radio>
                   </el-radio-group>
                 </el-form-item>


                 <el-form-item label="包邮" label-width="80px" prop="ship_free">
                <el-radio-group v-model="formData.ship_free" class="w200">
                  <el-radio v-for="item in locBaseData.is" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                  </el-radio-group>
                </el-form-item>


                 <el-form-item v-if="formData.ship_free==0" label="运费" label-width="80px" prop="express_cost">
                  <zw-input type="number" v-model="formData.express_cost"></zw-input>
                </el-form-item>

               </zw-row>


            <zw-row>
              <el-form-item label="状态" label-width="80px" prop="status">
                <el-radio-group v-model="formData.on_sale" class="w200">
                  <el-radio v-for="item in locBaseData.on_sale" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item>

              <el-form-item label="类型" label-width="80px" prop="type">
                <el-radio-group v-model="formData.type" class="w200">
                  <el-radio v-for="item in locBaseData.goodsType" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item>

              <el-form-item label="推荐" label-width="80px" prop="is_recommend" v-if="userInfo.group_id != 2">
                <el-radio-group v-model="formData.is_recommend" class="w200">
                  <el-radio v-for="item in locBaseData.is" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item>
            </zw-row>

            <zw-row>
              <!-- <el-form-item label="新品" label-width="80px" prop="is_new">
                <el-radio-group v-model="formData.is_new" class="w200">
                  <el-radio v-for="item in locBaseData.is" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item> -->

              <el-form-item label="分销" label-width="80px" prop="is_commission">
                <el-radio-group v-model="formData.is_commission" class="w200">
                  <el-radio v-for="item in locBaseData.is" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item>

              <el-form-item label="爆款" label-width="80px" prop="is_hot" v-if="userInfo.group_id != 2" >
                <el-radio-group v-model="formData.is_hot" class="w200">
                  <el-radio v-for="item in locBaseData.is" :label="item.id" :key="item.id">{{item.name}}</el-radio>
                </el-radio-group>
              </el-form-item>


            </zw-row>

          </div>

          <div v-show="tabActive==2">
            <el-form-item label-width="80px" label="内容">
              <div>
                <rich-txt v-if="!m_tableLoading" width="100%" ref="richTxt" :content="formData.content" />
              </div>
            </el-form-item>

          </div>

          <div v-show="tabActive==3">
            <zw-btn class="mb10" @click="addParams" btnType="add">添加</zw-btn>
            <el-table size="mini" :data="formData.params" border style="width: 100%">
              <el-table-column prop="title" width="200" label="参数名称" align='center'>
                <template slot-scope="scope">
                  <zw-input v-model="scope.row.title" />
                </template>

              </el-table-column>
              <el-table-column prop="value" label="值" align='center'>
                <template slot-scope="scope">
                  <zw-input v-model="scope.row.value" />
                </template>
              </el-table-column>
              <el-table-column width="100" prop="sort" label="排序" align='center'>
                <template slot-scope="scope">
                  <zw-input type="number" v-model="scope.row.sort" />
                </template>
              </el-table-column>
              <el-table-column prop="sort" label="操作" width="100" align='center'>
                <template slot-scope="scope">
                  <zw-btn @click="delParams(scope.$index)" type="text">删除</zw-btn>
                </template>
              </el-table-column>
            </el-table>

          </div>

          <div v-if="tabActive==4">
            <setOptions ref="setOptions" :options="formData.options" />
          </div>

        </el-form>
      </div>
      <div slot="footer">
        <el-button @click="Show = false">关 闭</el-button>
        <el-button :loading="btnLoading" type="primary" @click="handelSetMenu">确 定</el-button>
      </div>
    </el-dialog>

    <goodsClassTree :ids="formData.category" @saveAfter="saveAfter" v-if="goodsClassShow" :show.sync="goodsClassShow" />
  </div>
</template>

<script>
import goodsClassTree from './goodsClassTree'
import setOptions from './setOptions/index'
import richTxt from '@/components/richTxt'
export default {
  name: 'addFormDialog',
  components: { richTxt, goodsClassTree, setOptions },
  props: {
    value: {
      required: true,
      type: Boolean,
    },
    id: {
      type: [String, Number]
    },
  },

  computed: {
    Show: {
      get() {
        return this.value
      },
      set(v) {
        this.$emit('input', v)
      }
    }
  },
  data() {
    return {
      isSetOptions: true,
      goodsClassShow: false,
      m_tableLoading: false,
      btnLoading: false,
      source_from:[],
      tabActive: '1',
      userInfo:{},
      currentComponent: null,
      formData: {
        id: '',
        title: '',//标题
        images: [],//图片
        price: '',//价格
        content: '',//内容
        original_price: '',//原价
        cost_price: '',//成本
        sort: '0',//排序 (从大到小排序)
        sale_num: '',//虚拟销量
        stock: '',//库存
        receipt_required: 0,
        on_sale: '1',//上架状态 0:下架 1:上架
        type: '1',//产品类型  1:实体  2:虚拟
        is_recommend: '0',//是否推荐  0:否 1:是
        is_new: '1',//是否新品  0:否 1:是
        ship_free: '1',//是否包邮 0:否 1:是
        express_cost:'0', //运费
        is_commission: '0', //是否参与分销 0: 否 1:是. 默认为0
        is_hot: '0', //爆款
        unit: '',//单位,如个/件/箱
        weight: '',//重量(克)
        source_from: '0',//产品来源 数据字典 goods.source_from
        category: [],//分类ID
        options: {}, //规格集合
        params: [], //产品参数
        category_info: [],
        total_limit:0 , //总限购,
        item_endprice: '',
        min_item_endprice: '',
        reward_mode : '',
      },


      paramsItem: {
        title: '',
        sort: '0',
        value: '',
        id: '0',
      },

      m_rules: {
        title: [{ required: true, message: '请输入' }],
        price: [{ required: true, message: '请输入' }],
        cost_price: [{ required: true, message: '请输入' }],
        original_price: [{ required: true, message: '请输入' }],
        sale_num: [{ required: true, message: '请输入' }],
        stock: [{ required: true, message: '请输入' }],
        category_info: [{ required: true, message: '请上传' }],
        images: [{ required: true, message: '请上传' }],

      }
    }
  },

  mounted() {
    this.init()
    
  },

  methods: {
    //初始化方法
    init() {
       this.userInfo = sessionStorage.userInfo && JSON.parse(sessionStorage.userInfo) || {}
      this.getGoodsInfo()
      this.sourceFrom() 
     
    },

   open(url) {
    //  window.open(url, "_blank");
    this.m_copy(url,()=>{
      this.m_success('复制成功')
    })
    },

    getGoodsInfo() {
      if (this.id) {
        this.m_tableLoading = true
        this.m_api.goods_show({ id: this.id }).then(res => {
          this.formData = res.data;
          this.formData.receipt_required = parseInt(res.data.receipt_required);
          this.m_tableLoading = false
        }).catch(err => {
          this.m_tableLoading = false
        })
      }
    },

    sourceFrom() {
      let data= this.GetBaseData('goods','source_from')
        for(var i=0; i<data.length; i++) { 
            if(this.userInfo.group_id == 2) {
                if (data[i].name !== "专区券产品"){
                  this.source_from.push(data[i])
                }
            }
            else { 
              this.source_from.push(data[i])
            }
        }
        console.log('data', this.source_from)
    },

    rewardMode() { 
        if (this.formData.reward_mode == 0 ) { 
        
          this.formData.reward_mode = 1 
          this.currentComponent=1 
         
          }
        else { 
          this.formData.reward_mode = 0 
          this.currentComponent=null
        }
        console.log(this.formData.reward_mode) 
      } ,

    handelSetMenu() {
      // this.$refs.setOptions.createdRule()
      let apiKey
      this.formData.content = this.$refs.richTxt.getContent()
      apiKey = this.id ? 'goods_update' : 'goods_add'

      this.$refs['ruleForm'].validate((valid) => {
        if (valid) {
          this.btnLoading = true
          this.m_api[apiKey](this.formData).then(res => {
            this.btnLoading = false
            this.$emit('handelSubmit')
            this.Show = false
            this.m_success('操作成功')
            this.btnLoading = false

          }).catch(err => {
            this.btnLoading = false
          })
        } else {
          this.m_warning('请完整填写基本信息')
          console.log('error submit!!');
          return false;
        }
      })


    },

    handleChoose() {
      this.goodsClassShow = true
    },

    saveAfter(info) {
      this.formData.category_info = info.map(i => { return { name: i.name, id: i.id } })
      this.formData.category = this.formData.category_info.map(i => i.id)

    },

    closeTag(row, index) {
      this.formData.category_info.splice(index, 1)
      this.formData.category = this.formData.category_info.map(i => i.id)
    },

    addParams() {
      this.formData.params.push(this._dep(this.paramsItem))
    },

    delParams(index) {
      this.formData.params.splice(index, 1)
    },

    handleAvatarSuccessImgs(res, file) {
      console.log(res)
      this.formData.images.push(res.data)
    },
    delImgs(index) {
      this.formData.images.splice(index, 1)
    }
  },
  watch: {

  },
  filters: {

  }
}

</script>
<style lang='scss' scoped>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
  border: 1px dashed #d9d9d9;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
  border: 1px dashed #d9d9d9;
}

.imgss {
  position: relative;
  display: inline-block;
  .imgss_color {
    position: absolute;
    top: 5px;
    right: 5px;
    font-size: 18px;
    color: #999;
  }
  .imgss_color:hover {
    color: #333;
  }
}
</style>